######################
# Materiały pomocnicze do przedmiotu ZMADBM
# Wyklad 8
# Grupowanie obiektów oraz selekcja cech.
# dr inż. Michal Dramiński
######################

#grupowanie hierarchiczne
#działa tylko dla danych numerycznych!!!
d <- dist(as.matrix(mtcars))   # macierz odległości
hc <- hclust(d)                # jest wejściem do procedury hclust
plot(hc)                       # narysuj dendrogram


#grupowanie algorytmem k-means
library(cluster)
clus <- kmeans(mtcars, centers = 3)
data.frame(clus$cluster[order(clus$cluster)])


#filtry sa tak proste ze trzeba je sobie zaimplementowac we wlasnym zakresie
#jest pakiet FSelector ktory uzywa RWeka czyli filtrow zaimplementowanych w popularnym
#pakiecie Weka (Java)
# :)


#Stepwise regression
#forward selection jest troche bardziej skomplikowane w uruchomieniu
#najpierw budujemy minimalny i maksymalny model
min.model <- lm(mpg~1, data=mtcars)
max.model <- lm(mpg~., data=mtcars)
#wyjscie jest za to bardzo jasne w interpretacji
step(min.model, scope=list(lower=min.model, upper=max.model), direction="forward")


### las losowy
library(randomForest)
# tu bedziemy szukac zmiennych pomagajacych w klasyfikacji cyl
my_mtcars <- mtcars
my_mtcars$cyl <- as.factor(my_mtcars$cyl)
classifier.rf <- randomForest(cyl~., data = my_mtcars, importance=T)
#zmienna importance lasu losowego przechowuje MeanDecreaseGini
#im wieksza wartość tym istotniejsza cecha
classifier.rf$importance


### algorytm Boruta
library(Boruta)
my_mtcars <- mtcars
my_mtcars$cyl <- as.factor(my_mtcars$cyl)
boruta.result <- Boruta(cyl~., data = my_mtcars)
#boruta potwierdza albo odrzuca zmienne nie buduje rankingu
boruta.result$finalDecision


### algorytm MCFS
library(rmcfs)
my_mtcars <- mtcars
my_mtcars$cyl <- as.factor(my_mtcars$cyl)
mcfs.result <- mcfs(cyl~., data = my_mtcars)
#zmienna RI wyniku zawiera df z rankingiem
#im wyższe RI_norm tym cecha bardziej istotna
mcfs.result$RI


